#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second 
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define make_unique(x) sort(all(x)), x.erase(unique(all(x)), x.end())

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
mt19937_64 Rng(chrono::steady_clock::now().time_since_epoch().count());

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const int N = 1e6 + 200;
const int M = 1e6;
const int inf = 2e9 + 3;
const ll INF = 1e18;

const int mod = 998244353;

int add(int a, int b) {
    if (a + b >= mod) return a + b - mod;
    return a + b;
}

int mul(int a, int b) {
    return a * 1ll * b % mod;
}

int bp(int a, int n) {
    int r = 1;
    while (n) {
        if (n&1) r = mul(r, a);
        a = mul(a, a);
        n /= 2;
    }
    return r;
}

int n, m, k;

int get(int d) {
    if (d % 2 == 1) {
        return mul((k-2), bp(add(k-1, mul(k-2, k-2)), (d - 3) / 2));
    }
    else {
        return bp(add(k-1, mul(k-2, k-2)), (d - 2) / 2);
    }
}

pair<int, int> p[N];
map<int, int> val;
set<pair<int, int>> g[N];
int ival[N];
set<pair<int, int>> edges;
int ans = 0;

int go(int l, int r) {
    if (r > l) return r - l;
    else return n - (l - r);
}

void find(int v, int last) {
    int len = 0;
    int st = last;
    while (true) {
        auto pp = g[last].lower_bound({v, -inf});
        assert(pp->F == v);
        /* cerr << last << " " << v << " " << pp->S << '\n'; */
        len += pp->S;
        g[last].erase(pp);
        edges.erase({last, v});
        if (v == st) break;
        if (v < last) {
            auto it = g[v].lower_bound({last, -inf});
            assert(it != g[v].begin());
            it--;
            int u = it->F;
            last = v;
            v = u;
        }
        else {
            auto it = g[v].lower_bound({last, -inf});
            if (it == g[v].begin()) {
                it = g[v].end();
            }
            assert(it != g[v].begin());
            --it;
            int u = it->F;
            last = v;
            v = u;
        }
    }
    ans = mul(ans, get(len));
    /* cerr << "FOUND: " << len << '\n'; */
}

void solve() {
    cin >> n >> m >> k;
    ans = mul(k, k - 1);
    if (m == 0) {
        ans = mul(ans, get(n));
        cout << ans << '\n';
        return;
    }
    set<int> used;
    for (int i = 1, v, u; i <= m; ++i) {
        cin >> v >> u;
        used.insert(v);
        used.insert(u);
        used.insert(v + 1);
        used.insert(u + 1);
        p[i] = {v, u};
    }
    int s = 0;
    val.clear();
    for (auto v : used) {
        val[v] = ++s;
        ival[s] = v;
    }
    for (int i = 1; i <= s; ++i) {
        g[i].clear();
    }
    edges.clear();
    for (int i = 1; i <= m; ++i) {
        int v = val[p[i].F], u = val[p[i].S];
        edges.insert({v, u});
        edges.insert({u, v});
        g[v].insert({u, 1});
        g[u].insert({v, 1});
    }
    for (int i = 1; i <= s; ++i) {
        if (i != s) {
            g[i].insert({i + 1, go(ival[i], ival[i + 1])%mod});
        }
        else {
            g[i].insert({1, go(ival[i], ival[1])%mod});
        }
    }
    while (edges.size()) {
        auto it = edges.begin();
        int v = it->F, u = it->S;
        /* cerr << v << " " << u << ":\n"; */
        find(u, v);
    }
    cout << ans << '\n';
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
    int T;
    cin >> T;
    while (T--) solve();
}
