import java.util.*;

public class Main {
    static final int MOD = 998244353;

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int t = sc.nextInt(); // Количество тестов

        StringBuilder sb = new StringBuilder(); // Для вывода результатов

        while (t-- > 0) {
            int n = sc.nextInt(); // Количество углов
            int m = sc.nextInt(); // Количество разрезов
            int k = sc.nextInt(); // Количество цветов

            if (m >= n) { // Слишком много разрезов
                sb.append(0).append("\n");
                for (int i = 0; i < 2 * m; i++) sc.nextInt();
                continue;
            }

            // Пропускаем ввод разрезов (нам важен только m)
            for (int i = 0; i < 2 * m; i++) sc.nextInt();

            int components = n - m; // Количество связных компонент
            long result = (long) k * modPow(k - 1, components - 1, MOD) % MOD;
            sb.append(result).append("\n");
        }

        System.out.print(sb);
    }

    // Быстрое возведение в степень по модулю
    private static long modPow(long base, int exp, int mod) {
        long result = 1;
        while (exp > 0) {
            if ((exp & 1) == 1) result = result * base % mod;
            base = base * base % mod;
            exp >>= 1;
        }
        return result;
    }
}

