#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

// Function to convert the time in hh:mm format to total minutes
int timeToMinutes(string time) {
    int hours = stoi(time.substr(0, time.find(':')));
    int minutes = stoi(time.substr(time.find(':') + 1));
    return hours * 60 + minutes;
}

int main() {
    int n;
    cin >> n;
    vector<int> alarms(n);

    // Read the alarms and convert them to minutes
    for (int i = 0; i < n; i++) {
        string time;
        cin >> time;
        alarms[i] = timeToMinutes(time);
    }

    // Sort the alarms (though input guarantees it's sorted)
    sort(alarms.begin(), alarms.end());

    // Check if existing alarms already guarantee waking up
    for (int i = 0; i <= n - 3; i++) {
        if (alarms[i + 2] - alarms[i] <= 10) {
            cout << 0 << endl;
            return 0; // No additional alarms are needed
        }
    }

    // If not, calculate the minimum additional alarms needed
    int additionalAlarms = 0;
    vector<int> allAlarms = alarms; // Copy of the existing alarms

    // Add alarms until the condition is satisfied
    for (int i = 0; i <= n + additionalAlarms - 3; i++) {
        while (i + 2 < allAlarms.size() && allAlarms[i + 2] - allAlarms[i] > 10) {
            int newAlarm = allAlarms[i] + 10; // Add an alarm within the required range
            allAlarms.push_back(newAlarm);
            additionalAlarms++;
            sort(allAlarms.begin(), allAlarms.end()); // Re-sort after adding
        }
    }

    cout << additionalAlarms << endl;
    return 0;
}