#include <bits/stdc++.h>
#define toe tie

using namespace std;

const int MAXN = (int)2e5 + 10;
int n, m, col[MAXN], cnt;
bool used[MAXN];
vector <int> g[MAXN], gr[MAXN], comp[MAXN], g1[MAXN], condense;

void topsort(int v, vector <int>& cmp) {
    // cout << "topsort #" << v << "\n";
    used[v] = true;
    for (int to: g[v]) {
        if (!used[to]) {
            topsort(to, cmp);
        }
    }
    cmp.push_back(v);
}

void component(int v, int k) {
    // cout << "component #" << v << " " << k << "\n";
    used[v] = true;
    col[v] = k;
    comp[k].push_back(v);
    for (size_t it = 0; it < gr[v].size(); it++) {
        int to = gr[v][it];
        if (!used[to]) {
            component(to, k);
        }
    }
}

void build(int v) {
    // cout << "build #" << v << "\n";
    used[v] = true;
    for (size_t it = 0; it < g[v].size(); it++) {
        int to = g[v][it];
        if (!used[to]) {
            if (col[v] != col[to]) {
                g1[col[v]].push_back(col[to]);
            }
            build(to);
        }
    }
}

void sort_condense(int v) {
    // cout << "sorting condensed graph #" << v << "\n";
    used[v] = true;
    for (size_t it = 0; it < g1[v].size(); it++) {
        int to = g1[v][it];
        if (!used[to]) {
            sort_condense(to);
        }
    }
    condense.push_back(v);
}

void inside_compsort(int v, vector <int> &ord) {
    //cout << "inside strong component #" << v << "\n";
    used[v] = true;
    for (size_t it = 0; it < g[v].size(); it++) {
        int to = g[v][it];
        if (!used[to] && col[to] == col[v]) {
            inside_compsort(to, ord);
        }
    }
    ord.push_back(v);
}

void testcase() {
    condense.clear();
    for (int i = 0; i <= n + 3; i++) {
        used[i] = false;
        g[i].clear();
        gr[i].clear();
        g1[i].clear();
        comp[i].clear();
        col[i] = 0;
    }

    cin >> n >> m;

    //cout << "prompt\n";
    for (int i = 1; i <= m; i++) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        gr[v].push_back(u);
        // cout << "#" << i << " inserted\n";
    }

    vector <int> cmp;
    for (int i = 1; i <= n; i++) {
        if (!used[i]) {
            topsort(i, cmp);
        }
    }
    reverse(cmp.begin(), cmp.end());

    fill(used, used + 3 + n, false);

    cnt = 0;
    for (int it = 0; it < n; it++) {
        int v = cmp[it];
        if (!used[v]) {
            cnt++;
            component(v, cnt);
        }
    }

    fill(used, used + 3 + n, false);
    for (int v = 1; v <= n; v++){
        if (!used[v]) {
            build(v);
        }
    }

    fill(used, used + 3 + n, false);
    for (int i = 1; i <= cnt; i++) {
        if (!used[i]) {
            sort_condense(i);
        }
    }
    reverse(condense.begin(), condense.end());

    fill(used, used + 3 + n, false);
    vector <int> ans;
    for (size_t it = 0; it < condense.size(); it++) {
        int cond = condense[it];
        vector <int> ord;
        for (size_t it1 = 0; it1 < comp[cond].size(); it1++) {
            int v = comp[cond][it1];
            if (!used[v]) {
                inside_compsort(v, ord);
            }
        }
        reverse(ord.begin(), ord.end());
        // cout << "ordered inside strong component size = " << ord.size() << "\n";
        for (size_t j = 0; j < ord.size(); j++) {
            ans.push_back(ord[j]);
        }
    }

    // cout << ans.size() << "\n";
    for (size_t it = 0; it < ans.size(); it++) {
        cout << ans[it] << " ";
    }
    cout << "\n";
}

int main() {
    //ios_base::sync_with_stdio(false);
    //cin.toe(nullptr); cout.toe(nullptr);

    int t;
    cin >> t;
    while (t--) {
        testcase();
    }
    
    return 0;
}
