#include <iostream>
#include <vector>
#include <string>
#include <limits.h>

int minsFromTime(std::string &time)
{
    std::string hoursStr = "", minsStr = "";
    int mode = 0;

    for (auto it = time.begin(); it != time.end(); std::advance(it, 1))
    {
        if (*it == ':')
            mode = 1;
        else
        {
            if (mode == 0)
                hoursStr += *it;
            else
                minsStr += *it;
        }
    }

    const int hours = std::stoi(hoursStr);
    const int mins = std::stoi(minsStr);

    return 60 * hours + mins;
}

int calcAddAlarms(const std::vector<int> &alarms)
{
    if (alarms.size() == 1)
    {
        return 2;
    }
    else if (alarms.size() == 2)
    {
        if (alarms[1] - alarms[0] <= 10)
            return 1;
        else
            return 2;
    }

    auto p = alarms.begin();

    // int curDiff = 0;
    int addAlarms = 2;
    int len = alarms.size();

    for (int i = 0; i < alarms.size() - 2; ++i)
    {
        int d1 = alarms[i + 1] - alarms[i];
        if (10 >= d1)
        {
            addAlarms = 1;
            if (10 >= alarms[i + 2] - alarms[i + 1] + d1)
            {
                return 0;
            }
        }
    }

    if (10 >= alarms[len - 1] - alarms[len - 2])
    {
        return 1;
    }

    return addAlarms;
}

int main()
{
    std::ios_base::sync_with_stdio(false);

    int n;

    std::cin >> n;

    std::vector<int> alarms(n);

    for (int i = 0; i < n; ++i)
    {
        std::string time;
        std::cin >> time;
        alarms[i] = minsFromTime(time);
    }

    int addAlarms = calcAddAlarms(alarms);

    std::cout << addAlarms << std::flush;

    return 0;
}
