#include <iostream>
#include <vector>

int handleCase(std::pair<std::vector<int>, std::vector<int>> &cs) {
    int maxDiff = 0;
    for (int i = 0; i < cs.first.size(); ++i) {
        int diff = cs.second[i] - cs.first[i];

        if (diff < 0) return -1;

        maxDiff = std::max(diff, maxDiff);
    }
    return maxDiff;
}

int main()
{
    std::ios_base::sync_with_stdio(false);

    int n;

    std::cin >> n;

    std::vector<std::pair<std::vector<int>, std::vector<int>>> cases(n);

    for (int i = 0; i < n; ++i)
    {
        int mntNum;
        std::cin >> mntNum;
        std::vector<int> mntBefore(mntNum);
        std::vector<int> mntAfter(mntNum);

        for (int j = 0; j < mntNum; ++j)
        {
            std::cin >> mntBefore[j];
        }
        for (int j = 0; j < mntNum; ++j)
        {
            std::cin >> mntAfter[j];
        }

        cases[i] = std::make_pair(mntBefore, mntAfter);
    }

    for (int i = 0; i < n; ++i) {
        std::cout << handleCase(cases[i]) << '\n';
    }

    std::cout << std::flush;

    return 0;
}
