#include <iostream>
#include <vector>

int handleCase(std::pair<std::vector<int>, std::vector<int>> &cs)
{
    const auto len = cs.first.size();

    const auto &mntBefore = cs.second;
    const auto &mntAfter = cs.first;

    auto mntCur = cs.second;

    int years = 0;
    for (int i = 0; i < len; ++i)
    {
        int diff = mntBefore[i] - mntAfter[i];

        if (diff < 0) // mountain can't grow
            return -1;

        years = std::max(diff, years);
    }

    for (int i = 0; i < years; ++i)
    {
        // calc max diff (min years)
        int maxDiff = 0;
        int x = INT_MAX;
        for (int i = 0; i < len; ++i)
        {
            int diff = mntBefore[i] - mntAfter[i];

            if (diff < 0) // mountain can't grow
                return -1;

            maxDiff = std::max(diff, maxDiff);
        }

        // find mountains that have maxDiff
        for (int i = 0; i < len; ++i)
        {
            if (mntCur[i] - mntAfter[i] == maxDiff)
            {
                x = std::min(x, mntCur[i]);
            }
        }

        // erode all mountains that are taller than x
        for (int i = 0; i < len; ++i)
        {
            if (mntCur[i] >= x)
                --mntCur[i];
            if (mntCur[i] < mntAfter[i])
                return -1;
        }
    }
    return years;
}

int main()
{
    std::ios_base::sync_with_stdio(false);

    int n;

    std::cin >> n;

    std::vector<std::pair<std::vector<int>, std::vector<int>>> cases(n);

    for (int i = 0; i < n; ++i)
    {
        int mntNum;
        std::cin >> mntNum;
        std::vector<int> mntBefore(mntNum);
        std::vector<int> mntAfter(mntNum);

        for (int j = 0; j < mntNum; ++j)
        {
            std::cin >> mntBefore[j];
        }
        for (int j = 0; j < mntNum; ++j)
        {
            std::cin >> mntAfter[j];
        }

        cases[i] = std::make_pair(mntBefore, mntAfter);
    }

    for (int i = 0; i < n; ++i)
    {
        std::cout << handleCase(cases[i]) << '\n';
    }

    std::cout << std::flush;

    return 0;
}
