def solve_erosion(test_cases):
    results = []

    for n, h, p in test_cases:
        if any(p[i] < h[i] for i in range(n)):
            results.append(-1)
            continue

        if all(p[i] == h[i] for i in range(n)):
            results.append(0)
            continue

        diffs = [p[i] - h[i] for i in range(n)]
        years = max(diffs)

        for x in range(1, years + 1):
            erosion = [max(0, diff - x) for diff in diffs]
            if all(val == 0 for val in erosion):
                results.append(x)
                break
        else:
            results.append(-1)

    return results

test_cases = [
    (4, [3, 2, 4, 2], [5, 3, 6, 2]),
    (1, [10], [100000]),
    (5, [1, 2, 3, 4, 5], [1, 2, 3, 4, 5]),
    (3, [1, 4, 6], [4, 1, 8])
]

output = solve_erosion(test_cases)

for result in output:
    print(result)
