#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int solveErosion(int n, vector<int>& h, vector<int>& p) {
    for (int i = 0; i < n; ++i) {
        if (p[i] < h[i]) {
            return -1;
        }
    }

    bool equal = true;
    for (int i = 0; i < n; ++i) {
        if (p[i] != h[i]) {
            equal = false;
            break;
        }
    }

    if (equal) {
        return 0;
    }

    int maxDiff = 0;
    for (int i = 0; i < n; ++i) {
        maxDiff = max(maxDiff, p[i] - h[i]);
    }

    return maxDiff;
}

int main() {
    int t;
    cin >> t;

    while (t--) {
        int n;
        cin >> n;

        vector<int> h(n), p(n);
        for (int i = 0; i < n; ++i) {
            cin >> h[i];
        }
        for (int i = 0; i < n; ++i) {
            cin >> p[i];
        }

        cout << solveErosion(n, h, p) << endl;
    }

    return 0;
}
