from itertools import product

def reachable(n, m, maze, start, blocked=set()):
    moves = [(-1, 0), (1, 0), (0, -1), (0, 1)]
    queue, visited = [start], set(start)
    while queue:
        x, y = queue.pop()
        if maze[x][y] == 'f':
            return True
        for dx, dy in moves:
            nx, ny = x + dx, y + dy
            if 0 <= nx < n and 0 <= ny < m and maze[nx][ny] != '#' and (nx, ny) not in visited | blocked:
                visited.add((nx, ny))
                queue.append((nx, ny))
    return False

for _ in range(int(input())):
    n, m = map(int, input().split())
    maze = [input() for _ in range(n)]
    start = [(i, j) for i, j in product(range(n), range(m)) if maze[i][j] == 's'][0]
    if not reachable(n, m, maze, start):
        print(-1)
        continue
    res = float('inf')
    empty = [(i, j) for i, j in product(range(n), range(m)) if maze[i][j] == '.']
    for i, j in empty:
        if not reachable(n, m, maze, start, {(i, j)}):
            res = min(res, 1)
    for (i1, j1), (i2, j2) in product(empty, repeat=2):
        if abs(i1 - i2) + abs(j1 - j2) == 1:
            if not reachable(n, m, maze, start, {(i1, j1), (i2, j2)}):
                res = min(res, 2)
    print(res if res != float('inf') else -1)
