from collections import deque

def bfs(n, m, maze, start, block=None):
    directions = [(-1, 0), (1, 0), (0, -1), (0, 1)]
    visited = [[False] * m for _ in range(n)]
    queue = deque([start])
    visited[start[0]][start[1]] = True

    while queue:
        x, y = queue.popleft()
        if maze[x][y] == 'f':
            return True
        for dx, dy in directions:
            nx, ny = x + dx, y + dy
            if 0 <= nx < n and 0 <= ny < m and maze[nx][ny] != '#' and not visited[nx][ny]:
                if block and (nx, ny) in block:
                    continue
                visited[nx][ny] = True
                queue.append((nx, ny))
    return False

t = int(input())
for _ in range(t):
    n, m = map(int, input().split())
    maze = [input().strip() for _ in range(n)]
    start = next((i, j) for i in range(n) for j in range(m) if maze[i][j] == 's')
    if not bfs(n, m, maze, start):
        print(-1)
        continue

    min_wall = float('inf')
    for i in range(n):  # Проверяем блокировку одной клетки
        for j in range(m):
            if maze[i][j] == '.':
                if not bfs(n, m, maze, start, block={(i, j)}):
                    min_wall = min(min_wall, 1)
    for i in range(n):  # Проверяем горизонтальные стены
        for j in range(m - 1):
            if maze[i][j] == '.' and maze[i][j + 1] == '.':
                if not bfs(n, m, maze, start, block={(i, j), (i, j + 1)}):
                    min_wall = min(min_wall, 2)
    for j in range(m):  # Проверяем вертикальные стены
        for i in range(n - 1):
            if maze[i][j] == '.' and maze[i + 1][j] == '.':
                if not bfs(n, m, maze, start, block={(i, j), (i + 1, j)}):
                    min_wall = min(min_wall, 2)

    print(min_wall if min_wall != float('inf') else -1)
