from itertools import product

def is_reachable(n, m, maze, start, blocked=set()):
    directions = [(-1, 0), (1, 0), (0, -1), (0, 1)]
    queue = [start]
    visited = set()
    visited.add(start)

    while queue:
        x, y = queue.pop()
        if maze[x][y] == 'f':
            return True

        for dx, dy in directions:
            nx, ny = x + dx, y + dy
            if 0 <= nx < n and 0 <= ny < m and maze[nx][ny] != '#' and (nx, ny) not in visited and (nx, ny) not in blocked:
                queue.append((nx, ny))
                visited.add((nx, ny))

    return False

t = int(input())
for _ in range(t):
    n, m = map(int, input().split())
    maze = [input().strip() for _ in range(n)]

   
    start = None
    for i in range(n):
        for j in range(m):
            if maze[i][j] == 's':
                start = (i, j)
                break
        if start:
            break


    if not is_reachable(n, m, maze, start):
        print(-1)
        continue

    min_wall = float('inf')


    for i in range(n):
        for j in range(m):
            if maze[i][j] == '.':
                if not is_reachable(n, m, maze, start, blocked={(i, j)}):
                    min_wall = min(min_wall, 1)

   
    for i in range(n):
        for j in range(m - 1):
            if maze[i][j] == '.' and maze[i][j + 1] == '.':
                if not is_reachable(n, m, maze, start, blocked={(i, j), (i, j + 1)}):
                    min_wall = min(min_wall, 2)

    for j in range(m):
        for i in range(n - 1):
            if maze[i][j] == '.' and maze[i + 1][j] == '.':
                if not is_reachable(n, m, maze, start, blocked={(i, j), (i + 1, j)}):
                    min_wall = min(min_wall, 2)

   
    print(min_wall if min_wall != float('inf') else -1)
