#include <iostream>
#include <vector>
#include <string>
#include <cstdlib>

struct Alarm{
    int hour;
    int minute;
};

void printAlarm(Alarm a){
    std::cout << "\"" << a.hour << "\":\"" << a.minute << "\"" << std::endl;
}

std::vector<std::string> split(std::string s, char pat){
    std::vector<std::string> result;
    std::string temp;
    for(int i = 0; i < s.size(); ++i){
        if(s[i] == pat){
            result.push_back(temp);
            temp.clear();
            continue;
        }
        temp.push_back(s[i]);
    }
    result.push_back(temp);
    return result;
}

Alarm strToAlarm(std::string str){
    std::vector<std::string> v = split(str, ':');
    return Alarm{atoi(v[0].c_str()), atoi(v[1].c_str())};
}
//                         5      56
int calculate_interval(int a, int b){
    if(a < b){
        return a + 60 - b;
    }
    return a - b;
}

int main(){
    int n;
    std::cin >> n;
    std::vector<Alarm> alarms;
    for(int i = 0; i < n; ++i){
        std::string a;
        std::cin >> a;
        alarms.push_back(strToAlarm(a));
    }
    int samy_krutoy_interval = 1;
    for(int i = 0; i < alarms.size() - 2; ++i){
        int minute_1 = alarms[i].minute;
        int minute_2 = alarms[i+1].minute;
        int minute_3 = alarms[i+2].minute;
        if(calculate_interval(minute_3, minute_1) <= 10){
            samy_krutoy_interval = 3;
            break;
        }
        else if(calculate_interval(minute_3, minute_2) <= 10 or calculate_interval(minute_2, minute_1) <= 10){
            samy_krutoy_interval = 2;
        }
    }
    std::cout << 3 - samy_krutoy_interval;
}
