def min_bricks(l, h):
    # dp[i] will store the minimum number of 1x3 bricks required to fill a length i
    dp = [float('inf')] * (l + 1)
    dp[0] = 0  # No bricks are needed for length 0
    
    # Fill the dp array for lengths from 1 to l
    for i in range(1, l + 1):
        if i >= 3:
            dp[i] = min(dp[i], dp[i - 3] + 1)  # Using one 1x3 brick
        if i >= 2:
            dp[i] = min(dp[i], dp[i - 2])  # Using one 1x2 brick
    
    # The minimum number of 1x3 bricks needed is dp[l] * h because the wall has height h
    return dp[l] * h

# Input reading
l, h = map(int, input().split())
# Output the result
print(min_bricks(l, h))
