def solve():
    t = int(input())  # Number of test cases
    
    for _ in range(t):
        n = int(input())  # Number of servers
        a = list(map(int, input().split()))  # Loads on the servers
        
        # Calculate total load
        total_load = sum(a)
        
        # The maximum possible equal load L
        max_possible_L = total_load // n
        
        # Check if it is possible to achieve max_possible_L
        surplus = 0  # This will track the surplus that can be redistributed
        for i in range(n):
            # Current surplus is the difference between the current load and the target load
            surplus += a[i] - max_possible_L
            
            # If at any point, surplus goes negative, it means we can't reduce load efficiently
            # (because a[i] is too small to handle the load reduction)
            if surplus < 0:
                break
        else:
            # If we never break due to negative surplus, then it's feasible
            print(max_possible_L)
            continue
        
        # If it's not feasible, we need to adjust the max_possible_L downwards
        print(max_possible_L - 1)
