import java.util.Scanner;

public class Main {

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int l = sc.nextInt(); // length of the wall
        int h = sc.nextInt(); // height of the wall

        // dp[i][j] represents the minimum number of 1x3 bricks used to construct
        // a wall of length i and height j
        int[][] dp = new int[l + 1][h + 1];
        
        // Initialize dp table. Fill with a large number because we want to minimize the number.
        for (int i = 0; i <= l; i++) {
            for (int j = 0; j <= h; j++) {
                dp[i][j] = Integer.MAX_VALUE;
            }
        }
        
        // Base case: No bricks, no wall, no cost.
        dp[0][0] = 0;

        // Iterating over all heights and lengths
        for (int i = 0; i <= l; i++) {
            for (int j = 0; j <= h; j++) {
                if (dp[i][j] == Integer.MAX_VALUE) continue;
                
                // Try placing a 1x2 brick
                if (i + 2 <= l) {
                    dp[i + 2][j] = Math.min(dp[i + 2][j], dp[i][j] + 0);
                }

                // Try placing a 1x3 brick
                if (i + 3 <= l) {
                    dp[i + 3][j] = Math.min(dp[i + 3][j], dp[i][j] + 1);
                }
            }
        }

        // the result is dp[l][h] print the minimum bricks used to build
