import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);

        int t = sc.nextInt();  // количество тестов
        while (t-- > 0) {
            int n = sc.nextInt();  // количество серверов
            long[] a = new long[n];
            
            long sum = 0;
            for (int i = 0; i < n; i++) {
                a[i] = sc.nextLong();
                sum += a[i];
            }
            
            // Максимальная возможная нагрузка
            long maxPossibleLoad = sum / n;
            
            // Для проверки, можем ли мы достичь этой нагрузки
            long remainingAdjustment = 0;
            boolean isPossible = true;
            
            for (int i = 0; i < n; i++) {
                // Текущий разрыв от целевой нагрузки
                long diff = a[i] - maxPossibleLoad;
                
                // Попытка "перераспределить" разницу на следующий сервер
                remainingAdjustment += diff;
                
                // Если на каком-то этапе разница становится отрицательной, это невозможно
                if (remainingAdjustment < 0) {
                    isPossible = false;
                    break;
                }
            }

            // Выводим максимальную возможную нагрузку
            if (isPossible) {
                System.out.println(maxPossibleLoad);
            } else {
                System.out.println(maxPossibleLoad - 1);
            }
        }
        
        sc.close();
    }
}
