import java.util.*;

public class Main {
    
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        
        // Reading number of alarms
        int n = sc.nextInt();
        sc.nextLine();  // consume the newline
        
        // List to store alarm times in minutes after 7:00
        List<Integer> alarms = new ArrayList<>();
        
        // Reading all alarm times
        for (int i = 0; i < n; i++) {
            String time = sc.nextLine();
            String[] parts = time.split(":");
            int hour = Integer.parseInt(parts[0]);
            int minute = Integer.parseInt(parts[1]);
            
            // Convert time to minutes from 7:00 AM
            int totalMinutes = (hour - 7) * 60 + minute;
            alarms.add(totalMinutes);
        }
        
        // We need to check if there is already a valid group of three alarms within 10 minutes
        if (canWakeUp(alarms)) {
            System.out.println(0);
            return;
        }
        
        // Try to find the minimum number of alarms to add
        // The interval [0, 120] represents time in minutes from 7:00 to 9:00
        int minNewAlarms = Integer.MAX_VALUE;
        
        // Try adding alarms one by one and check if the condition is met
        for (int additional = 1; additional <= 20; additional++) {
            minNewAlarms = Math.min(minNewAlarms, tryAddingAlarms(alarms, additional));
        }
        
        System.out.println(minNewAlarms);
    }
    
    // Helper function to check if there is a group of three alarms within 10 minutes
    private static boolean canWakeUp(List<Integer> alarms) {
        int n = alarms.size();
        
        // Check every triplet of alarms
        for (int i = 0; i < n - 2; i++) {
            for (int j = i + 1; j < n - 1; j++) {
                for (int k = j + 1; k < n; k++) {
                    if (alarms.get(k) - alarms.get(i) <= 10) {
                        return true;
                    }
                }
            }
        }
        
        return false;
    }
    
    // Function to try adding a number of new alarms and see if the condition is met
    private static int tryAddingAlarms(List<Integer> alarms, int newAlarms) {
        // List to store possible new alarms
        List<Integer> allAlarms = new ArrayList<>(alarms);
        
        // Try to add new alarms at various positions
        for (int i = 0; i < newAlarms; i++) {
            allAlarms.add(i * 10);  // Arbitrary decision to add alarms at fixed intervals
        }
        
        // Now check if we can wake up after adding the alarms
        if (canWakeUp(allAlarms)) {
            return newAlarms;
        }
        
        return Integer.MAX_VALUE;
    }
}
